/* Draw RGB bands */

#define IOBASE		0x04000000
#define VIDEO_MODE3	0x0F03
#define COLOR_RED	(0x1F)
#define COLOR_GREEN	(0x1F << 5)
#define COLOR_BLUE	(0x1F << 10)
#define VRAM_START	0x06000000
#define LOOP_COUNT	(240 * (160 / 3))

.arm
.text
	mov r1, #IOBASE		// Set I/O base address
	ldr r2, =VIDEO_MODE3	// Set video mode 3
	strh r2, [ r1 ]

	// R3 VRAM pointer
	// R4 color code
	// R5 loop counter

	mov r3, #VRAM_START	// Set VRAM frame buffer address

	ldr r4, =COLOR_RED	// RGB = 0/0/1F RED
	ldr r5, =LOOP_COUNT	// Reset counter
display_red:
	strh r4, [ r3 ]		// Change the dot color
	add r3, r3, #2		// Forward VRAM pointer (2 bytes)
	subs r5, r5, #1		// Decrement counter
	bne display_red		// If NOT EQUAL to zero, then repeat

	ldr r4, =COLOR_GREEN	// RGB = 0/1F/0 GREEN
	ldr r5, =LOOP_COUNT	// Reset counter
display_green:
	strh r4, [ r3 ]		// Change the dot color
	add r3, r3, #2		// Forward VRAM pointer (2 bytes)
	subs r5, r5, #1		// Decrement counter
	bne display_green	// If NOT EQUAL to zero, then repeat

	ldr r4, =COLOR_BLUE	// RGB = 1F/0/0 BLUE
	ldr r5, =LOOP_COUNT	// Reset counter
display_blue:
	strh r4, [ r3 ]		// Change the dot color
	add r3, r3, #2		// Forward VRAM pointer (2 bytes)
	subs r5, r5, #1		// Decrement counter
	bne display_blue	// If NOT EQUAL to zero, then repeat
loop:
	b loop			// Loop forever
