// Load image data and display it on the screen

#define IOBASE		0x04000000
#define VIDEO_MODE3	0x0F03
#define VRAM_START	0x06000000
#define LOOP_COUNT	(240 * 160)

.arm
.text
	mov r1, #IOBASE		// Set I/O base address
	ldr r2, =VIDEO_MODE3	// Set video mode 3
	strh r2, [ r1 ]

	// R2 color code
	// R3 VRAM pointer
	// R4 image buffer pointer
	// R5 loop counter

	mov r3, #VRAM_START	// Set VRAM frame buffer address
	ldr r4, =image_start	// Set start address of image buffer
	ldr r5, =LOOP_COUNT	// Reset counter
display:
	ldrh r2, [ r4 ]		// Load color code from image buffer
	strh r2, [ r3 ]		// And store it to VRAM frame buffer
	add r3, r3, #2		// Forward VRAM pointer (2 bytes)
	add r4, r4, #2		// Forward image pointer (2 bytes)
	subs r5, r5, #1		// Decrement counter
	bne display		// If NOT EQUAL to zero, then repeat
loop:
	b loop			// Loop forever
